<?php

/*
	*** Please read !!!

	$contacts is 2D array.
	$contacts:
			$contacts[0]["Name"], $contacts[0]["Email"],
			$contacts[1]["Name"], $contacts[1]["Email"],
			$contacts[2]["Name"], $contacts[2]["Email"],
			...
			$contacts[...]["Name"], $contacts[...]["Email"]
	$emailfile is absolute/ complete path to combined pdf document
	$emailfile:
			/var/www/archiv/uploads/2021-04-14_160735775570/

root@archivpi:/var/www/archiv/uploads# ls 2021-04-14_160735775570 -l
insgesamt 4692
-rw-r--r-- 1 www-data www-data	700951 Apr 14 16:08 crypt_webarchiv_DrsMaierSchulze_2021-04-14_16:07_35775570.zip
-rw-r--r-- 1 www-data www-data	  2245 Apr 14 16:11 FaxCover_2021-04-14_160735775570.txt
-rw-r--r-- 1 www-data www-data	  2228 Apr 14 16:11 FaxCover_2021-04-14_160735775570.txt.iso88
-rw-r--r-- 1 www-data www-data	   340 Apr 14 16:08 Password_2021-04-14_160735775570.html
-rw-r--r-- 1 www-data www-data	 19209 Apr 14 16:08 Password_2021-04-14_160735775570.pdf
-rw-r--r-- 1 www-data www-data 3361228 Mär 30 23:33 testDocument_2021-03-30.pdf
-rw-r--r-- 1 www-data www-data	701219 Apr 14 16:08 webarchiv_DrsMaierSchulze_2021-04-14_16:07_35775570.zip

*/
function SendEmail($contacts, $CCcemail, $textsubject, $textmessage, $Attachment, $AttachmentFiles) {

	$ccemail = $CCcemail; // commented out
	$bccemail = "egerlach@aiai.de"; // commented out
	$emails = "";
	GLOBAL $emailAttachMax;
	$success = false;
	foreach($contacts as $contact) {
		$name = $contact["Name"]; // can be empty
		$email = $contact["EMail"]; // not empty
		//$emailfile = $AttachmentFiles;
		$success = false;

		if (trim($email) != "") { // check if email valid etc
			// Send Email command - Number: $email, Document: $emailfile
			//$success = true;
			$from_email 		= 'egerlach@zeitprax.com'; //from mail, sender email addrress
			$sender_name	= "Eckard Gerlach";
			$reply_to_email = $from_email;
			$recipient_email	= $email;
			$subject		= $textsubject; //subject for the email
			$message = "";
			//if ($attachmentvalid) {

			//}
			$message .= $textmessage;
			$message .= "";

			// Advertisement
			/*if (file_exists("webarchiv-advert-email.html")) {
				$message .= "<br />" . file_get_contents("webarchiv-advert-email.html");
			}*/

			//read from the uploaded file & base64_encode content
			/*if ($attachmentvalid) {
				$handle = fopen($emailfile, "r");  // set the file handle only for reading the file
				$content = fread($handle, filesize($emailfile)); // reading the file
				fclose($handle);				  // close upon completion
				$encoded_content = chunk_split(base64_encode($content));
			}*/
			$boundary = md5("random"); // define boundary with a md5 hashed value
			if (trim($name) != "") {
				$recipient = $name . " <" . $email . ">";
			} else {
				$recipient = $email;
			}
			//header
			//$headers = "MIME-Version: 1.0\r\n"; // Defining the MIME version
			$headers = "From: " . $sender_name . " <" . $from_email . ">\r\n"; // Sender Email
			//$headers .= "To: " . $recipient . "\r\n"; // Email address to reach back
			$headers .= "Date: " . date("r") . "\r\n"; // Date
			$headers .= "Reply-To: " . $sender_name . " <" . $reply_to_email . ">\r\n"; // Email addrress to reach back
			$headers .= "Cc: " . $ccemail . "\r\n"; // Email addrress to cc
			$headers .= "Bcc: " . $bccemail . "\r\n"; // Email addrress to cc
			//$headers .= "Subject: $subject\r\n"; // Defining the MIME version
			$headers .= "MIME-Version: 1.0\r\n"; // Defining the MIME version
			$headers .= "Content-Type: multipart/mixed; "; // Defining Content-Type
			$headers .= "boundary=$boundary\r\n\r\n"; //Defining the Boundary --

			//plain text
			$body = "--$boundary\r\n";
			$body .= "Content-Type: text/html; charset=UTF-8\r\n";
			$body .= "Content-Transfer-Encoding: base64\r\n\r\n";
			$body .= chunk_split(base64_encode($message)). ""; //--
			//$body .= "--$boundary--";
			//$headers .= "boundary = $boundary\r\n"; //Defining the Boundary
			//$body .= $encoded_content; // Attaching the encoded file with email

			
			//read from the uploaded file & base64_encode content
			foreach ($AttachmentFiles as $afile) {
				if (file_exists($afile) && (!is_dir($afile)) && (filesize($afile) < $emailAttachMax) && ($Attachment)) {
					$handle = fopen($afile, "r");  // set the file handle only for reading the file
					$content = fread($handle, filesize($afile)); // reading the file
					fclose($handle);				  // close upon completion
					$encoded_content = chunk_split(base64_encode($content));

					$exp = explode(DIRECTORY_SEPARATOR, $afile);
					$fname = end($exp);
					
					$Archivemimetype = mime_content_type($afile);

					$body .= "--$boundary\r\n";
					$body .="Content-Type: $Archivemimetype; name=".$fname."\r\n";
					$body .="Content-Disposition: attachment; filename=".$fname."\r\n";
					$body .="Content-Transfer-Encoding: base64\r\n";
					$body .="X-Attachment-Id: ".rand(1000, 99999)."\r\n\r\n";
					$body .= $encoded_content; // Attaching the encoded file with email
				}
			}
			/*
			if (($attachmentvalid) && (filesize($emailfile) < $emailAttachMax)) {
				$body .= "--$boundary\r\n";
				$body .="Content-Type: $Archivemimetype; name=".$fname."\r\n";
				$body .="Content-Disposition: attachment; filename=".$fname."\r\n";
				$body .="Content-Transfer-Encoding: base64\r\n";
				$body .="X-Attachment-Id: ".rand(1000, 99999)."\r\n\r\n";
				$body .= $encoded_content; // Attaching the encoded file with email
			}*/
			$body .= "\r\n";
			$body .= "--$boundary--";

			$success = mail($recipient_email, $subject, $body, $headers);
			if ($success)
			{
				if (strlen($emails) > 0) {
					$emails .= "<br />";
				}
				$emails .= $email;
			}
			// copy to server
			//--$cpcmd = "cp " . $archivefile . " /var/www/maildownload/";
			//$success = true;//mail($recipient, $subject, $body, $headers);
			//$success = mail("", "", $body, $headers);
		}
	}

	$ret = array();
	if ($success) {
		$ret[0] = true;
		$ret[1] = 0; // Modify canvas_functions.php line ~559 to remove displaying return code
		//$ret[2] = "xzxEmail sent to " . count($contacts) . " email address(es):<br />" . $emails;
		$ret[2] = "xzxEmail sent to " . $emails;
	} else {
		$ret[0] = false;
		$ret[1] = "E-123";
		$ret[2] = "<br /><strong>Type: </strong>" . error_get_last()["type"] . "<br /><strong>Message: </strong>" . error_get_last()["message"] . "<br />";
	}
	// return array [ (bool) success, (number/ string) error_code, (string) error_description ];
	return $ret;
}

?>
